/*
 * timer.c
 *
 *  Created on: 25.06.2015
 *      Author: martin
 */

#include "timer.h"
#include "stm32f4xx_hal.h"
#include "stm32f4xx_hal_tim.h"

void systickInit()
{
	HAL_SYSTICK_Config(1000);
}



/* PWM Mode */
void timer3Init()
{
	/* Variables */
	TIM_HandleTypeDef initTimPWM;
	TIM_OC_InitTypeDef pwmConfig;

	/* enable clock */
	__HAL_RCC_TIM3_CLK_ENABLE();


	// Init timer 3
	initTimPWM.Instance = TIM3;
	initTimPWM.Init.Prescaler = 345;
	initTimPWM.Init.Period = 345;
	initTimPWM.Init.ClockDivision = 0;
	initTimPWM.Init.CounterMode = TIM_COUNTERMODE_UP;

	if(HAL_TIM_PWM_Init(&initTimPWM) != HAL_OK)
	{
		//errorHandler("Tim3 init pwm failed");
	}

	// init PWM
	pwmConfig.OCMode = TIM_OCMODE_PWM1;
	pwmConfig.OCPolarity = TIM_OCPOLARITY_HIGH;
	pwmConfig.OCFastMode = TIM_OCFAST_DISABLE;

	// channel 1
	// dutycycle in %: 50
	pwmConfig.Pulse = 50/100*initTimPWM.Init.Period;
	if(HAL_TIM_PWM_ConfigChannel(&initTimPWM, &pwmConfig, TIM_CHANNEL_1) != HAL_OK)
	{
		//errorHandler("Tim3 channel 1 pwm config failed");
	}
	if(HAL_TIM_PWM_Start(&initTimPWM, TIM_CHANNEL_1) != HAL_OK)
	{
		//errorHandler("Tim 3 channel 1 pwm start failed");
	}




}
